.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ReTool-2.0.inc

.code

s macro arg:VARARG
	EXITM chr$(arg)
endm

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	DialogBoxParam,hInstance,1000,NULL,addr DlgProc,NULL
	invoke	ExitProcess,0

;########################################################################

DlgProc	proc	hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
      
	.if	uMsg==WM_INITDIALOG
		invoke SendMessage,hWnd,WM_SETTEXT,0,s("Test")
		invoke GetCtlHw,hWnd
		invoke CreateTolbar,hWnd
		invoke CreateDialogParam,hInstance,1200,hWnd,addr LogWindowProc,NULL
		mov hPlgDlgHosthW,eax
		
	.elseif	uMsg==WM_COMMAND
		mov eax,wParam
		.if eax > 10000 && eax < 10020
			invoke MenuHandler,hWnd,eax	
		.elseif eax == 1002
		.elseif eax == 51
			invoke RTLogMessage,s("ToolBar"),TRUE
		.endif
	.elseif	uMsg==WM_CLOSE
		invoke	EndDialog,hWnd,0
	.elseif uMsg == WM_SIZE
		invoke SendMessage,hToolBarhW,TB_AUTOSIZE,0,0
		invoke onResizeProc,hWnd
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp
MenuHandler proc hWnd:HWND,id:DWORD
	
	.if id == 10004
		invoke SendMessage,hWnd,WM_CLOSE,0,0
	.endif
	ret
MenuHandler endp
GetCtlHw proc hWnd:HWND
	
	invoke GetDlgItem,hWnd,1001
	mov hStatushW,eax
	invoke GetDlgItem,hWnd,1002
	mov hLogLBhW,eax
	
	ret
GetCtlHw endp
CreateTolbar proc hWnd:HWND
	local tbb:TBBUTTON
	local Tba:TBADDBITMAP
	
        mov tbb.iBitmap,   0
        mov tbb.idCommand, 0
        mov tbb.fsState,   TBSTATE_ENABLED
        mov tbb.fsStyle,   TBSTYLE_SEP
        mov tbb.dwData,    0
        mov tbb.iString,   0

        invoke CreateToolbarEx,hWnd,WS_CHILD or WS_CLIPSIBLINGS ,300,1,0,0,ADDR tbb,1,16,16,0,0,sizeof TBBUTTON
        mov hToolBarhW, eax
        invoke ShowWindow,hToolBarhW,SW_SHOW
        
        mov Tba.hInst, HINST_COMMCTRL
        mov Tba.nID, 2 

        invoke SendMessage,hToolBarhW,TB_ADDBITMAP,1,ADDR Tba


        mov tbb.iBitmap,   STD_FILEOPEN
        mov tbb.idCommand, 51
        mov tbb.fsStyle,   TBSTYLE_BUTTON
        invoke SendMessage,hToolBarhW,TB_ADDBUTTONS,1,ADDR tbb

	ret
CreateTolbar endp

LogWindowProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	.if uMsg == WM_INITDIALOG
		
		invoke CreateDialogParam,hInstance,1100,hWnd,addr TestWindowProc,NULL
		invoke CreateDialogParam,hInstance,1100,hWnd,addr TestWindowProc2,NULL
	.elseif uMsg == WM_PARENTNOTIFY
		.if wParam == WM_MOVE
			
		.endif
	.elseif uMsg == WM_COMMAND
	.elseif uMsg==WM_CTLCOLORDLG
		RGB 141,139,143
		invoke CreateSolidBrush,eax
		ret
	.else
	
	mov	eax,FALSE
	ret
	.endif
	mov	eax,TRUE
	ret
LogWindowProc endp
RTLogMessage proc lpMessage:DWORD,bShowTime:BOOL
	
	LOCAL fMsg[512]:BYTE
	LOCAL cMsg[256]:BYTE
	LOCAL systime:SYSTEMTIME
	pushad
	.if bShowTime==FALSE
		invoke lstrcpy,addr fMsg,SADD("                    ")
	.else
		invoke GetLocalTime,addr systime
		movzx eax,systime.wHour
		movzx ecx,systime.wMinute
		movzx edx,systime.wSecond
		invoke wsprintf,addr fMsg,SADD("[ %02d:%02d:%02d ] : "),eax,ecx,edx		
	.endif

	invoke lstrcat,addr fMsg,lpMessage
	
	invoke SendMessage,hLogLBhW,LB_ADDSTRING,0,addr fMsg
	invoke SendMessage,hLogLBhW,WM_VSCROLL,SB_BOTTOM,0

	popad
	ret
RTLogMessage endp
TestWindowProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	.if uMsg == WM_INITDIALOG
		
;	.elseif uMsg == WM_LBUTTONDOWN
;			invoke SetForegroundWindow,hWnd
;		invoke InvalidateRect,hWnd,0,TRUE
;		invoke UpdateWindow,hWnd
	.elseif uMsg == WM_CLOSE
		invoke EndDialog,hWnd,0
	.else
	mov	eax,FALSE
	ret
	.endif
	mov	eax,TRUE
	ret
TestWindowProc endp
TestWindowProc2 proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	.if uMsg == WM_INITDIALOG
;		.elseif uMsg == WM_LBUTTONDOWN
;			invoke SetForegroundWindow,hWnd
;			invoke InvalidateRect,hWnd,0,TRUE
;			invoke UpdateWindow,hWnd
;			
;		.elseif uMsg == WM_CLOSE
;			invoke EndDialog,hWnd,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
TestWindowProc2 endp
onResizeProc proc hWnd:HWND
	local recCL:RECT ;client rectangle
	local recSB:RECT ;statusbar rectangle
	local recLG:RECT ;logwindow rectangle
	local recPLH:RECT ;plugin host dlg
	local recTB:RECT ;toolbar rectangle
	local hDwp:HDWP 
	
	local _x:DWORD
	local _y:DWORD
	local _cx:DWORD
	local _cy:DWORD
	 
	invoke GetClientRect,hWnd,addr recCL
	
	invoke GetWindowRect,hStatushW,addr recSB
	mov eax,recSB.top
	sub recSB.bottom,eax
	
	invoke GetWindowRect,hLogLBhW,addr recLG
	mov eax,recLG.top
	sub recLG.bottom,eax
	
	invoke GetWindowRect,hPlgDlgHosthW,addr recPLH
	mov eax,recPLH.top
	sub recPLH.bottom,eax
	
	
	invoke BeginDeferWindowPos,3
	mov hDwp,eax
	
	mov eax,recCL.bottom
	mov ecx,recSB.bottom
	sub eax,ecx
	invoke DeferWindowPos,hDwp,hStatushW, NULL,0,eax,recCL.right,recSB.bottom,SWP_NOZORDER or SWP_NOACTIVATE
	
	mov _x,0
	mov eax,recCL.bottom
	mov ecx,recLG.bottom
	sub eax,ecx
	sub eax,24
	mov _y,eax
	mov eax,recCL.right
	mov _cx,eax
	mov eax,recLG.bottom
	mov _cy,eax
	invoke DeferWindowPos,hDwp,hLogLBhW, NULL,_x,_y,_cx,_cy,SWP_NOZORDER or SWP_NOACTIVATE
	
	
	mov _x,0
	mov _y,26
	mov eax,recCL.right
	mov _cx,eax
	mov eax,recLG.bottom
	mov ecx,recCL.bottom
	sub ecx,eax
	sub ecx,recSB.bottom
	sub ecx,_y
	sub ecx,11
	mov _cy,ecx
	invoke DeferWindowPos,hDwp,hPlgDlgHosthW, NULL,_x,_y,_cx,_cy,SWP_NOZORDER or SWP_NOACTIVATE	
		
	invoke EndDeferWindowPos,hDwp
	ret
onResizeProc endp
end start
